package org.gcube.portlets.widgets.ckancontentmoderator.client.ui;

import java.util.ArrayList;
import java.util.List;

import org.gcube.datacatalogue.utillibrary.shared.ItemStatus;
import org.gcube.portlets.widgets.ckancontentmoderator.client.ui.table.ItemsTable.DISPLAY_FIELD;

import com.github.gwtbootstrap.client.ui.CheckBox;
import com.github.gwtbootstrap.client.ui.Dropdown;
import com.github.gwtbootstrap.client.ui.NavLink;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTMLPanel;
import com.google.gwt.user.client.ui.Widget;

public class HomeView extends Composite {

	private static HomeViewUiBinder uiBinder = GWT.create(HomeViewUiBinder.class);
	private ContentModeratorSystemBaseView cmsPanel = new ContentModeratorSystemBaseView();
	private ContentModeratorPaginatedView paginatedView;

	@UiField
	HTMLPanel panelContainer;

	@UiField
	CheckBox cbSelectAll;

	@UiField
	Dropdown dropdownSetStatus;

	private List<NavLink> setStatusOptions = new ArrayList<>();

	private ItemStatus displayingItemStatus;

	interface HomeViewUiBinder extends UiBinder<Widget, HomeView> {
	}

	public HomeView(HandlerManager eventBus, ItemStatus status, DISPLAY_FIELD[] displayFields,
			DISPLAY_FIELD sortByField) {
		initWidget(uiBinder.createAndBindUi(this));
		this.displayingItemStatus = status;
		paginatedView = new ContentModeratorPaginatedView(eventBus, status, displayFields, sortByField);
		cmsPanel.addToCenter(paginatedView.getCellPanel());
		cmsPanel.addToBottom(paginatedView.getPagerPanel());
		panelContainer.add(cmsPanel.getPanel());

		fillSetStatusOptions();
	}

	private void fillSetStatusOptions() {
		for (ItemStatus status : ItemStatus.values()) {
			if (!status.equals(displayingItemStatus)) {
				NavLink nl = new NavLink(status.getLabel());
				dropdownSetStatus.add(nl);
				setStatusOptions.add(nl);
			}
		}

	}

	public Composite getPanel() {
		return this;
	}

}
